org.apache.hc.core5.http.impl.bootstrap

## Class HttpAsyncRequester

- java.lang.Object
- - org.apache.hc.core5.http.impl.bootstrap.AsyncRequester
  - - org.apache.hc.core5.http.impl.bootstrap.HttpAsyncRequester

- All Implemented Interfaces:
    Closeable, AutoCloseable, ModalCloseable, ConnPoolControl<HttpHost>, ConnPoolStats<HttpHost>, ConnectionInitiator, IOReactor, IOReactorService
  Direct Known Subclasses:
    H2AsyncRequester

      public class HttpAsyncRequester
      extends AsyncRequester
      implements ConnPoolControl<HttpHost>

  HTTP/1.1 client side message exchange initiator.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpAsyncRequester(IOReactorConfig ioReactorConfig, IOEventHandlerFactory eventHandlerFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, ManagedConnPool<HttpHost,IOSession> connPool)` Use `AsyncRequesterBootstrap` to create instances of this class.
    `HttpAsyncRequester(IOReactorConfig ioReactorConfig, IOEventHandlerFactory eventHandlerFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, ManagedConnPool<HttpHost,IOSession> connPool, TlsStrategy tlsStrategy, Timeout handshakeTimeout)` Use `AsyncRequesterBootstrap` to create instances of this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeExpired()`
    `void` | `closeIdle(TimeValue idleTime)`
    `Future<AsyncClientEndpoint>` | `connect(HttpHost host, Timeout timeout)`
    `Future<AsyncClientEndpoint>` | `connect(HttpHost host, Timeout timeout, Object attachment, FutureCallback<AsyncClientEndpoint> callback)`
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `protected Future<AsyncClientEndpoint>` | `doConnect(HttpHost host, Timeout timeout, Object attachment, FutureCallback<AsyncClientEndpoint> callback)`
    `protected void` | `doTlsUpgrade(ProtocolIOSession ioSession, NamedEndpoint endpoint, FutureCallback<ProtocolIOSession> callback)`
    `void` | `execute(AsyncClientExchangeHandler exchangeHandler, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext executeContext)`
    `void` | `execute(AsyncClientExchangeHandler exchangeHandler, Timeout timeout, HttpContext executeContext)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `void` | `execute(HttpHost target, AsyncClientExchangeHandler exchangeHandler, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext executeContext)`
    `<T> Future<T>` | `execute(HttpHost target, AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(HttpHost target, AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, FutureCallback<T> callback)`
    `int` | `getDefaultMaxPerRoute()`
    `int` | `getMaxPerRoute(HttpHost route)`
    `int` | `getMaxTotal()`
    `Set<HttpHost>` | `getRoutes()`
    `PoolStats` | `getStats(HttpHost route)`
    `PoolStats` | `getTotalStats()`
    `void` | `setDefaultMaxPerRoute(int max)`
    `void` | `setMaxPerRoute(HttpHost route, int max)`
    `void` | `setMaxTotal(int max)`

    - ### Methods inherited from class org.apache.hc.core5.http.impl.bootstrap.AsyncRequester

      `awaitShutdown, close, close, defaultTarget, getStatus, initiateShutdown, requestSession, start`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HttpAsyncRequester

          @Internal
          public HttpAsyncRequester(IOReactorConfig ioReactorConfig,
                                              IOEventHandlerFactory eventHandlerFactory,
                                              Decorator<IOSession> ioSessionDecorator,
                                              Callback<Exception> exceptionCallback,
                                              IOSessionListener sessionListener,
                                              ManagedConnPool<HttpHost,IOSession> connPool,
                                              TlsStrategy tlsStrategy,
                                              Timeout handshakeTimeout)

      Use `AsyncRequesterBootstrap` to create instances of this class.
      Since:
        5.2

    - #### HttpAsyncRequester

          @Internal
          public HttpAsyncRequester(IOReactorConfig ioReactorConfig,
                                              IOEventHandlerFactory eventHandlerFactory,
                                              Decorator<IOSession> ioSessionDecorator,
                                              Callback<Exception> exceptionCallback,
                                              IOSessionListener sessionListener,
                                              ManagedConnPool<HttpHost,IOSession> connPool)

      Use `AsyncRequesterBootstrap` to create instances of this class.

  - ### Method Detail

    - #### getTotalStats

          public PoolStats getTotalStats()

      Specified by:
        `getTotalStats` in interface `ConnPoolStats<HttpHost>`

    - #### getStats

          public PoolStats getStats(HttpHost route)

      Specified by:
        `getStats` in interface `ConnPoolStats<HttpHost>`

    - #### setMaxTotal

          public void setMaxTotal(int max)

      Specified by:
        `setMaxTotal` in interface `ConnPoolControl<HttpHost>`

    - #### getMaxTotal

          public int getMaxTotal()

      Specified by:
        `getMaxTotal` in interface `ConnPoolControl<HttpHost>`

    - #### setDefaultMaxPerRoute

          public void setDefaultMaxPerRoute(int max)

      Specified by:
        `setDefaultMaxPerRoute` in interface `ConnPoolControl<HttpHost>`

    - #### getDefaultMaxPerRoute

          public int getDefaultMaxPerRoute()

      Specified by:
        `getDefaultMaxPerRoute` in interface `ConnPoolControl<HttpHost>`

    - #### setMaxPerRoute

          public void setMaxPerRoute(HttpHost route,
                                     int max)

      Specified by:
        `setMaxPerRoute` in interface `ConnPoolControl<HttpHost>`

    - #### getMaxPerRoute

          public int getMaxPerRoute(HttpHost route)

      Specified by:
        `getMaxPerRoute` in interface `ConnPoolControl<HttpHost>`

    - #### closeIdle

          public void closeIdle(TimeValue idleTime)

      Specified by:
        `closeIdle` in interface `ConnPoolControl<HttpHost>`

    - #### closeExpired

          public void closeExpired()

      Specified by:
        `closeExpired` in interface `ConnPoolControl<HttpHost>`

    - #### getRoutes

          public Set<HttpHost> getRoutes()

      Specified by:
        `getRoutes` in interface `ConnPoolControl<HttpHost>`

    - #### connect

          public Future<AsyncClientEndpoint> connect(HttpHost host,
                                                     Timeout timeout,
                                                     Object attachment,
                                                     FutureCallback<AsyncClientEndpoint> callback)

    - #### doConnect

          protected Future<AsyncClientEndpoint> doConnect(HttpHost host,
                                                          Timeout timeout,
                                                          Object attachment,
                                                          FutureCallback<AsyncClientEndpoint> callback)

    - #### connect

          public Future<AsyncClientEndpoint> connect(HttpHost host,
                                                     Timeout timeout)

    - #### execute

          public void execute(HttpHost target,
                              AsyncClientExchangeHandler exchangeHandler,
                              HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                              Timeout timeout,
                              HttpContext executeContext)

      Since:
        5.3

    - #### execute

          public void execute(AsyncClientExchangeHandler exchangeHandler,
                              HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                              Timeout timeout,
                              HttpContext executeContext)

    - #### execute

          public void execute(AsyncClientExchangeHandler exchangeHandler,
                              Timeout timeout,
                              HttpContext executeContext)

    - #### execute

          public final <T> Future<T> execute(HttpHost target,
                                             AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

      Type Parameters:
        `T` - The result type returned by the Future's `get` method.
      Since:
        5.3

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

    - #### execute

          public final <T> Future<T> execute(HttpHost target,
                                             AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             FutureCallback<T> callback)

      Type Parameters:
        `T` - The result type returned by the Future's `get` method.
      Since:
        5.3

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             FutureCallback<T> callback)

    - #### doTlsUpgrade

          protected void doTlsUpgrade(ProtocolIOSession ioSession,
                                      NamedEndpoint endpoint,
                                      FutureCallback<ProtocolIOSession> callback)

    - #### connect

          public final Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                                 SocketAddress remoteAddress,
                                                 SocketAddress localAddress,
                                                 Timeout timeout,
                                                 Object attachment,
                                                 FutureCallback<IOSession> callback)

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.